#include "include_2col.h"

/***********************************************************************/
sm_su3mat sample_su3mats(void){



  sm_su3mat sample_su3;

  // mat 0 corresponds to 
  // 0 -i 0
  // i  0 0
  // 0  0 0
  sample_su3.mat[SU3_00].re[0] = 0.54030;
  sample_su3.mat[SU3_00].im[0] = 0.0;
  
  sample_su3.mat[SU3_01].re[0] = -0.84147;
  sample_su3.mat[SU3_01].im[0] = 0.0;
  
  sample_su3.mat[SU3_02].re[0] = 0.0;
  sample_su3.mat[SU3_02].im[0] = 0.0;
  /**/
  sample_su3.mat[SU3_10].re[0] = 0.84147;
  sample_su3.mat[SU3_10].im[0] = 0.0;
  
  sample_su3.mat[SU3_11].re[0] = 0.54030;
  sample_su3.mat[SU3_11].im[0] = 0.0;
  
  sample_su3.mat[SU3_12].re[0] = 0.0;
  sample_su3.mat[SU3_12].im[0] = 0.0;
  /**/
  sample_su3.mat[SU3_20].re[0] = 0.0;
  sample_su3.mat[SU3_20].im[0] = 0.0;
  
  sample_su3.mat[SU3_21].re[0] = 0.0;
  sample_su3.mat[SU3_21].im[0] = 0.0;
  
  sample_su3.mat[SU3_22].re[0] = 1.0;
  sample_su3.mat[SU3_22].im[0] = 0.0;
  
  // mat 1 corresponds to 
// 1  0  0
// 0  1  0  * 1/sqrt(3)
// 0  0 -2
  sample_su3.mat[SU3_00].re[1] =  0.83791;
  sample_su3.mat[SU3_00].im[1] = -0.54581;
  
  sample_su3.mat[SU3_01].re[1] = 0.0;
  sample_su3.mat[SU3_01].im[1] = 0.0;
  
  sample_su3.mat[SU3_02].re[1] = 0.0;
  sample_su3.mat[SU3_02].im[1] = 0.0;
  /**/
  sample_su3.mat[SU3_10].re[1] = 0.0;
  sample_su3.mat[SU3_10].im[1] = 0.0;
  
  sample_su3.mat[SU3_11].re[1] = 0.83791;
  sample_su3.mat[SU3_11].im[1] = -0.54581;
  
  sample_su3.mat[SU3_12].re[1] = 0.0;
  sample_su3.mat[SU3_12].im[1] = 0.0;
  /**/
  sample_su3.mat[SU3_20].re[1] = 0.0;
  sample_su3.mat[SU3_20].im[1] = 0.0;
  
  sample_su3.mat[SU3_21].re[1] = 0.0;
  sample_su3.mat[SU3_21].im[1] = 0.0;

  sample_su3.mat[SU3_22].re[1] = 1.0;
  sample_su3.mat[SU3_22].im[1] = 0.0;
  


  // mat 2 corresponds to 
  // 0  0  1
  // 0  0  0 
  // 1  0  0
  sample_su3.mat[SU3_00].re[1] =  1.54308;
  sample_su3.mat[SU3_00].im[1] =  0.0;
  
  sample_su3.mat[SU3_01].re[1] = 0.0;
  sample_su3.mat[SU3_01].im[1] = 0.0;
  
  sample_su3.mat[SU3_02].re[1] = -1.17520 ;
  sample_su3.mat[SU3_02].im[1] = 0.0;
  /**/
  sample_su3.mat[SU3_10].re[1] = 0.0;
  sample_su3.mat[SU3_10].im[1] = 0.0;
  
  sample_su3.mat[SU3_11].re[1] = 1.0;
  sample_su3.mat[SU3_11].im[1] = 0.0;
  
  sample_su3.mat[SU3_12].re[1] = 0.0;
  sample_su3.mat[SU3_12].im[1] = 0.0;
  /**/
  sample_su3.mat[SU3_20].re[1] = -1.17520;
  sample_su3.mat[SU3_20].im[1] =  0.0;
  
  sample_su3.mat[SU3_21].re[1] =  0.0;
  sample_su3.mat[SU3_21].im[1] =  0.0;
  
  sample_su3.mat[SU3_22].re[1] = 1.54308;
  sample_su3.mat[SU3_22].im[1] = 0.0;
  
  // mat 3 corresponds to 
  // mat1*mat2*mat2*mat3
  
  sample_su3.mat[SU3_00].re[1] =  0.11799;
  sample_su3.mat[SU3_00].im[1] =  - 0.26702;
  
  sample_su3.mat[SU3_01].re[1] = -0.34012;
  sample_su3.mat[SU3_01].im[1] =  0.76967;
  
  sample_su3.mat[SU3_02].re[1] = -0.41586;
  sample_su3.mat[SU3_02].im[1] = -0.18377;
  /**/
  sample_su3.mat[SU3_10].re[1] = 0.18377;
  sample_su3.mat[SU3_10].im[1] = -0.41586;
  
  sample_su3.mat[SU3_11].re[1] = 0.21839;
  sample_su3.mat[SU3_11].im[1] = -0.49420;
  
  sample_su3.mat[SU3_12].re[1] = -0.64766;
  sample_su3.mat[SU3_12].im[1] = - 0.28620;
  /**/
  sample_su3.mat[SU3_20].re[1] = 0.62219;
  sample_su3.mat[SU3_20].im[1] =  0.56653;
  
  sample_su3.mat[SU3_21].re[1] =  0.0;
  sample_su3.mat[SU3_21].im[1] =  0.0;
  
  sample_su3.mat[SU3_22].re[1] = -0.36376;
  sample_su3.mat[SU3_22].im[1] =  0.39950;


  return sample_su3;
  
}

/****************************************************************************/
void verify_su3(sm_su3mat *pmatM, int nummats){

  int indx;
  REAL mm02r;
  REAL mm12r;
  REAL mm22r;
  REAL mm02i;
  REAL mm12i;
  REAL mm22i;


  for (indx=0; indx<nummats; indx++){

    mm02r =	  
      (
	   pmatM->mat[SU3_10].re[indx]*pmatM->mat[SU3_21].re[indx]
	   - pmatM->mat[SU3_10].im[indx]*pmatM->mat[SU3_21].im[indx]
	   
	   - pmatM->mat[SU3_11].re[indx]*pmatM->mat[SU3_20].re[indx]
	   + pmatM->mat[SU3_11].im[indx]*pmatM->mat[SU3_20].im[indx]
       );



    
    
    // 0th component imag part
    
    
    mm02i =
      (
       pmatM->mat[SU3_10].re[indx]*pmatM->mat[SU3_21].im[indx]
       + pmatM->mat[SU3_10].im[indx]*pmatM->mat[SU3_21].re[indx]
       
       - pmatM->mat[SU3_11].re[indx]*pmatM->mat[SU3_20].im[indx]
       - pmatM->mat[SU3_11].im[indx]*pmatM->mat[SU3_20].re[indx]
       );
    
	  // component 1 --- real part   (M01*M20 - M00*M21)^* vecA[2]
    mm12r = 
      (
       pmatM->mat[SU3_01].re[indx]*pmatM->mat[SU3_20].re[indx]
       - pmatM->mat[SU3_01].im[indx]*pmatM->mat[SU3_20].im[indx]
       
       - pmatM->mat[SU3_00].re[indx]*pmatM->mat[SU3_21].re[indx]
       + pmatM->mat[SU3_00].im[indx]*pmatM->mat[SU3_21].im[indx]
       );
	  

	  // component 1 --- imag part
    mm12i =
      -(
       pmatM->mat[SU3_01].re[indx]*pmatM->mat[SU3_20].im[indx]
       + pmatM->mat[SU3_01].im[indx]*pmatM->mat[SU3_20].re[indx]
       
       - pmatM->mat[SU3_00].re[indx]*pmatM->mat[SU3_21].im[indx]
       - pmatM->mat[SU3_00].im[indx]*pmatM->mat[SU3_21].re[indx]
       );
    

	  // component 2 --- real part   (M00*M11 - M01*M10)^* vecA[2]
    mm22r=	
      (
       pmatM->mat[SU3_00].re[indx]*pmatM->mat[SU3_11].re[indx]
       - pmatM->mat[SU3_00].im[indx]*pmatM->mat[SU3_11].im[indx]
       
       - pmatM->mat[SU3_01].re[indx]*pmatM->mat[SU3_10].re[indx]
       + pmatM->mat[SU3_01].im[indx]*pmatM->mat[SU3_10].im[indx]
       );
	  



	  //  component 2 --- imag part:  (M00*M11 - M01*M10)^* vecA[2]
    mm22i =
      -(
       pmatM->mat[SU3_00].re[indx]*pmatM->mat[SU3_11].im[indx]
       + pmatM->mat[SU3_00].im[indx]*pmatM->mat[SU3_11].re[indx]
       
       - pmatM->mat[SU3_01].re[indx]*pmatM->mat[SU3_10].im[indx]
       - pmatM->mat[SU3_01].im[indx]*pmatM->mat[SU3_10].re[indx]
       );
	  

    printf("vec %d\n",indx);
    printf("m02r = %g\t%g\n",  mm02r,pmatM->mat[SU3_02].re[indx]);
    printf("m02i = %g\t%g\n\n",mm02i,pmatM->mat[SU3_02].im[indx]);
    
    
    printf("m12r = %g\t%g\n",  mm12r,pmatM->mat[SU3_12].re[indx]);
    printf("m12i = %g\t%g\n\n",mm12i,pmatM->mat[SU3_12].im[indx]);
    
    printf("m22r = %g\t%g\n",  mm22r,pmatM->mat[SU3_22].re[indx]);
    printf("m22i = %g\t%g\n\n\n",mm22i,pmatM->mat[SU3_22].im[indx]);


  }



}

/***************************************************************************/

void init_su3mats( su3mat *pmatM){


  int i,j;
  int picker_index;

  sm_su3mat sample_su3;

  sample_su3= sample_su3mats();

  // uncomment to check reconstruction algorithm
  //  verify_su3(&sample_su3, 4 );

  for(i=0; i< SU3MAT_SIZE; i++){
    for(j=0; j< VOLUME; j++){

      //tiny shuffling
      picker_index= (j%3+1);

      pmatM->mat[i].re[j]=sample_su3.mat[i].re[picker_index];
      pmatM->mat[i].im[j]=sample_su3.mat[i].re[picker_index];

    }
  }

}
