#!/usr/bin/bash

## use sbatch to submit this file on qpace3


#SBATCH --job-name=test
#SBATCH --nodes=1
#SBATCH --time=1:00:00
##SBATCH --partition=qp3
##SBATCH --account=jsc


# make sure libraries are findable
module use /bug/opt/modulefiles
module load  compiler/intel/17.0.2.174


#uncomment the below and change the number of threads
export OMP_NUM_THREADS=192

# change executable here
srun math_su3_test_unroll

echo "HHHHH"
# try numa binding
 srun numactl -m 4-7 ${HOME}/LATT_PRAC_EXERCISES/03_SU3_MULTIPLY/math_su3_test_unroll
echo "HHH"

 srun numactl -m 4-7 ${HOME}/LATT_PRAC_EXERCISES/03_SU3_MULTIPLY/math_su3_test_unroll_2col
